
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>MySQL 5.7.6 WL#7868 Innodb page flush优化 / iVAN</title>

    <meta name="description" content="MySQL 5.7.6 WL#7868 Innodb page flush优化 在上期的我们的月报(2015/2)中,我们已经针对Oracle MySQL以及社区版本最新的对innodb page flush的优化做了详细的介绍. 在最近release的5.7.6版本中又有了进一步的改进.     修改一.更精确的loop计算时间     Page cleaner会每做srv_flushing_avg_loops次后,会去计算刷脏和redo lsn增长的速度.由于每次Page cleaner的工作量是自适应的,一次flush操作的时间可能超过1秒,因此做N次loop的总时间">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">MySQL 5.7.6 WL#7868 Innodb page flush优化</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>在上期的我们的月报(<a href="http://mysql.taobao.org/index.php?title=MySQL%E5%86%85%E6%A0%B8%E6%9C%88%E6%8A%A5_2015.02" rel="external nofollow noreferrer">2015/2</a>)中，我们已经针对Oracle MySQL以及社区版本最新的对innodb page flush的优化做了详细的介绍。<br />
在最近release的5.7.6版本中又有了进一步的改进。</p>
<p> </p>
<p> </p>
<p><em>修改一、更精确的loop计算时间</em></p>
<p><em> </em></p>
<p> </p>
<p>Page cleaner会每做srv_flushing_avg_loops次后，会去计算刷脏和redo lsn增长的速度。由于每次Page cleaner的工作量是自适应的，一次flush操作的时间可能超过1秒，因此做N次loop的总时间可能超过N秒。</p>
<p> </p>
<p>在新版本中，统一采用当前时间和上次计算速率时间差来确认是否需要重新计算速率。因此参数innodb_flushing_avg_loops的行为实际上等同于每这么多秒后重计算速率。</p>
<p> </p>
<p> </p>
<p><em>修改二、根据buffer pool实例的脏页分布来决定刷脏</em></p>
<p> </p>
<p>我们知道从5.7版本开始支持多个page cleaner线程以实现并行刷脏。在5.7.6之前的版本中，page cleaner协调线程根据当前的负载情况，会计算出预计需要flush的总page数和目标lsn，然后在多个bp instance间做个均分。</p>
<p> </p>
<p>考虑一种场景：如果bp实例间的负载不平衡，某个实例在目标lsn之前的脏页很多，而有些实例很少，那么应该多作刷脏动作的bp就可能产生堆积。 我们之前在webscalesql google公开讨论组有过类似的讨论，感兴趣的可以看看。</p>
<p> </p>
<p>回到正题上来，在5.7.6版本中，计算目标page数的方法大概如下：</p>
<p>#根据当前脏页占比和lsn增长状态，计算利用IO CAPACITY的百分比（pct_total）</p>
<p>#计算目标lsn:</p>
<p>     target_lsn = oldest_lsn + lsn_avg_rate * buf_flush_lsn_scan_factor</p>
<p>其中oldest_lsn表示当前buffer pool中最老page的lsn，lsn_avg_rate表示每秒Lsn推进的平均速率，buf_flush_lsn_scan_factor目前是hardcode的，值为3。</p>
<p> </p>
<p>#统计每个buffer pool 小于target_lsn的page数pages_for_lsn</p>
<p>初步估定每个bp instance 的n_pages_requested= pages_for_lsn /buf_flush_lsn_scan_factor</p>
<p>每个bp的pages_for_lsn被累加到sum_pages_for_lsn</p>
<p> </p>
<p>#同时根据io capacity的百分比估算的总的page flush的量</p>
<p>sum_pages_for_lsn /= buf_flush_lsn_scan_factor;</p>
<p>n_pages = (PCT_IO(pct_total) + avg_page_rate + sum_pages_for_lsn) / 3;</p>
<p> </p>
<p>n_pages若超过innodb_io_capacity_max，则设置为innodb_io_capacity_max</p>
<p> </p>
<p>#轮询每个Buffer pool instance：</p>
<p>如果当前有足够的redo 空间时：n_pages_requested  = n_pages / srv_buf_pool_instances</p>
<p>否则：n_pages_requested = n_pages_requested  * n_pages / sum_pages_for_lsn</p>
<p>也就是说，在redo 空间足够时，依然采用均衡的刷脏逻辑。</p>
<p> </p>
<p>在早期版本中，会根据两个条件来判断每个bp刷脏的进度：目标LSN及page数。而到了5.7.6版本里，大多数情况下只根据更加准确的请求刷page数来进行判定 （系统空闲时进行100% io capactiy的page flush、崩溃恢复时、以及实例shutdown时的刷脏除外）</p>
<p> </p>
<p>虽然计算方式比较清晰，但有些factor的定值依然让人很困惑，也许是官方测试的比较理想的配置。不过最好还是设置成可配置的，由用户根据自己具体的负载情况来进行定制。</p>
<p> </p>
<p> </p>
<p><em>修改三、用户线程在检查redo 空间时不参与刷脏</em></p>
<p> </p>
<p>当redo file中未做checkpoint的日志量过多时，在早期版本中中用户线程会进行batch flush操作，将每个buffer pool instance的lsn推进到某个指定的LSN。如果某个bp instance已经有别的线程在flush，则跳过尝试下一个instance，同时认为这次的flush操作是失败的，会返回重试。</p>
<p> </p>
<p>当用户线程参与到刷脏时，通常会认为这是个性能拐点，TPS会出现急剧下降，大量线程陷入condtion wait。因此在5.7.6里，当用户线程需要推进LSN时，不再主动发起刷脏，而是轮询每个bp instance，直到所有的bp instance 的lsn超过其目标LSN，每次轮询默认sleep重试时间为10000微妙</p>
<p> </p>
<p>事实上, Percona Server在5.6版本里已经使用相同的策略了。</p>
<p> </p>
<p><em>修改四、为page cleaner线程设置更高的优先级</em></p>
<p> </p>
<p>在Linux平台下，对于page cleaner的协调线程和worker线程，其CPU优先级被设置为-20，即最高优先级，通过函数set_priority设置。目前还不支持参数配置</p>
<p> </p>
<p><em>修改五、防止checkpoint LSN被覆盖</em></p>
<p> </p>
<p>在之前的版本中，尽管每次在写redo时，都会去检察redo文件是否容留了足够百分比的可用空间，但实际上并没有考虑即将写入到的redo log长度。如果我们操作一些极大的记录时，产生很长的redo log记录，可能导致检查点LSN被覆盖掉，造成不能做安全的crash recovery。</p>
<p> </p>
<p>在新的逻辑里，在检测到当前写入的redo 可能造成覆盖检察点时，就会sleep等待page cleaner线程刷脏，并做redo log checkpoint。直到checkpoint的LSN推进到安全的位置。</p>
<p> </p>
<p> </p>
<p>除了上述几点外，还加入了更丰富的监控项</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 16:29:50</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>MySQL 5.7.6 WL#7868 Innodb page flush优化的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQWAnp.html" rel="bookmark">MySQL内核月报 2015&period;03-MySQL &CenterDot; 性能优化&CenterDot; 5&period;7&period;6 InnoDB page flush 优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上期的月报中,我们已经详细介绍了Oracle MySQL以及社区分支最新的对InnoDB page flush的优化.在最近release的5.7.6版本中又有了进一步的改进.主要包括以下几点修改 修改一.更精确的loop时间 Page cleaner每做srv_flushing_avg_loops次flush后,会去计算刷脏和Redo LSN增长的速度.由于每次Page cleaner的工作量是自适应的,一次flush操作的时间可能超过1秒. 在新版本中,统一采用当前时间和上次更新速率的时间			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL87yLp.html" rel="bookmark">MySQL 5&period;7&period;6&colon; wl&num;5757 InnoDB支持大page</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				worklog: http://dev.mysql.com/worklog/task/?id=5757 官方mysql 在git上代码比较零散,具体的实现我们可以参考webscalesql上的代码:https://reviews.facebook.net/D31107 或者在webscalesql的git上: git show ebd27a35db6ef2267efd69da392e5efdc77611a6 我们知道Innodb的默认page size为16KB.在MySQL5.6版本里我们可以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z40G9jz.html" rel="bookmark">MySQL内核月报 2014&period;08-MariaDB&CenterDot;分支特性&CenterDot;支持大于16K的InnoDB Page Size</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 最近发布的MariaDB 10.1 Alpha版本,提交了一个改动,放宽了InnoDB Page&lt;=16K的限制,将上限提高到64K. 从MDEV-6075需求文档中可以看出,目前只支持COMPACT的结构,DYNAMIC结构能否支持还在研究,COMPRESSED结构则确定无法支持. 业务应用 什么情况下需要64K这么大的页面呢? 我们知道一个Page,不是所有的page_size都可以用来存数据,还有一些管理信息要存,例如页头和页尾(InnoDB Page). 此外,InnoDB Buf			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqaQK3M.html" rel="bookmark">innblock 工具&vert; InnoDB page观察利器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				innblock | InnoDB page观察利器 特别鸣谢 笔者是知数堂早期学员,最初有写这么一个工具的想法也得到叶金荣老师的认可和鼓励,这个想法也整整耗掉了好几个晚上的休息时间,这里再次感谢叶金荣老师对工具审核,叶老师的经验和学识是每一位学员宝贵的财富. 感谢&lt;&gt;主要作者周彦伟.王竹峰.强昌金对本工具的认可并授权引用部分内容,如果大家对本文的内容感到吃力可以自行参考该书,也可以和书中部分章节配合使用学习. 感谢我所在的易极付公司DBA团队同事戴正勇.杨海波.田兴椿.邹启健,在我研究和编写			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGAxQkM.html" rel="bookmark">ubuntu 安装mysql 5&period;5&period;28 编译安装 innodb 配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				安装环境:ubuntu 桌面版12.10 安装版本:mysql-5.5.28.tar.gz 使用root用户安装 su root 在出现的提升中输入密码 1.安装必备工具 1.1.安装cmake编译器 apt-get install cmake 1.2.安装libncurses5-dev包 apt-get install libncurses5-dev 1.3.安装bison apt-get install bison 1.4 安装g++ apt-get install g++ 2.安装mysq			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgRZjmb.html" rel="bookmark">mysql建表unknown storage engine innodb</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 mysql建表unknown storage engine innodb 建表的时候出现的问题,网上百度了一下给出的方法都没有解决. 解决方案			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ2Yk6z.html" rel="bookmark">MySQL存储引擎中MyISAM和InnoDB区别详解&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				InnoDB和MyISAM是许多人在使用MySQL时最常用的两个表类型,这两个表类型各有优劣,视具体应用而定.基本的差别为:MyISAM类型不支持事务处理等高级处理,而InnoDB类型支持.MyISAM类型的表强调的是性能,其执行数度比InnoDB类型更快,但是不提供事务支持,而InnoDB提供事务支持以及外部键等高级数据库功能. 以下是一些细节和具体实现的差别: ◆1.InnoDB不支持FULLTEXT类型的索引. ◆2.InnoDB 中不保存表的具体行数,也就是说,执行select coun			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyKVGdz.html" rel="bookmark">MySQL数据库MyISAM存储引擎转为Innodb的方法&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql数据库存储引擎为MyISAM的时候,在大访问量的情况下数据表有可能会出现被锁的情况,这就会导致用户连接网站时超时而返回502,此时就需要MySQL数据库MyISAM存储引擎转为Innodb.步骤如下: 1.导出CentOS数据库的表结构 复制代码 代码如下: mysqldump -d -uxxx -p centos &gt; centos_table.sql 其中-d参数表示不导出数据,只导出表结构 2.替换centos_table.sql里的MyISAM为INNODB 复制代码 代码如下:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6k7DWp.html" rel="bookmark">Mysql 的存储引擎&comma;myisam和innodb的区别&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简单的表达.  MyISAM 是非事务的存储引擎.  innodb是支持事务的存储引擎.    innodb的引擎比较适合于插入和更新操作比较多的应用  而MyISAM 则适合用于频繁查询的应用    MyISAM --表锁.  innodb--设计合理的话是行锁.  MyISAM 不会出现死锁.    最大的区别就是MYISAM适合小数据,小并发:INNODB 适合大数据,大并发.最大的区别就是在锁的级别上.    MyISAM类型不支持事务处理等高级处理,而InnoDB类型支持. MyISA			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBPxop.html" rel="bookmark" class="title">带数据库的ajax&plus;asp无限级分类树型结构&comma;好东西别错过！</a>
					<div>
						跟大家分享一下自己写的一个树型结构,参考了动力文章的无限极分类树形结构数据库,看演示吧http://asptree.guaishi.org/aspajax/ 下面是核心类代码,注释是后来加的,可能有些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWqeGz.html" rel="bookmark" class="title">用tar包配置高可用性vsftp &lpar;中&rpar;</a>
					<div>
						二.高级配置 1.使用独立服务 a.vi/etc/xinetd.d/vsftpd把disable=no还改成yes,不再需要它了! b.vi/etc/vsftpd.conf在结尾加上listen=YE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mv3g5p.html" rel="bookmark" class="title">管理SQL Server 登录</a>
					<div>
						14.2.1 用SQLServer Enterprise Manager 管理SQL Server 登录 在SQL Server 中,通过SQL Server Enterprise Manager 执 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo466M.html" rel="bookmark" class="title">中搜搅局搜索之战 整合能力待考验</a>
					<div>
						搜索引擎是互联网的第一入口,其背后是超过五亿的用户规模,一直被视为&quot;兵家必争之地&quot;.2012年下半年,&quot;3B大战&quot;引起主管机构的介入刚刚平息,中搜公司携带其研发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bonqDz.html" rel="bookmark" class="title">深度剖析Duwamish 7&period;0 &lpar;1--数据结构&rpar;</a>
					<div>
						数据|数据结构 不好意思啊,让大家久等了,第一次写这种文章,可能没有开心那么专业,废话少说,我们开始: 1．结构概述Duwamish 7.0 结构分为四个逻辑层: Web 层 Web 层为客户端提供对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6WNEz.html" rel="bookmark" class="title">PhotoShop制作滚动图片GIF动画效果图文教程</a>
					<div>
						教程利用PhotoShop制作滚动图片GIF动画效果,考虑制作滚动图像多样性效果,我分别介绍三种不同的方法来制作有差异的动画效果,分别是:平行单向滚动动态效果,往复式滚动动画效果和开关门式滚动动画.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8P40p.html" rel="bookmark" class="title">电脑没有网盘如何实现文件同步</a>
					<div>
						  网盘同步功能实际上是将网盘服务器上文件和本地同步目录的文件进行比对,然后对新文件进行自动复制.因此对于用服务器共享目录实现共享的用户,如果要实现同步功能,我们只要利用复制工具实现自动复制即可. 由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJ3O2p.html" rel="bookmark" class="title">Photoshop中的蒙版的使用技巧</a>
					<div>
						  蒙版是PS学习中最重要的技能之一.本教程中将和大家分享10个有关蒙版的使用技巧,以帮助大家更好的使用蒙版制作有趣的.令人激动的效果.一起学习吧! 1.渐变蒙版用于柔和过渡 在一个图层蒙版上使用渐变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3jB6p.html" rel="bookmark" class="title">NLPIR技术助力中文智能数据挖掘</a>
					<div>
						随着数据技术的飞速发展以及广泛应用,许多企业和部门建立了自身的数据管理系统,经过长年努力,已经积累了越来越多的数据.于是,人们开始渴望通过对这些庞大的数据分析得到更多的有助于决策的信息.虽然,目前的数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZda96M.html" rel="bookmark" class="title">解决数据库保存中文乱码问题</a>
					<div>
						输入中文时数据库中显示为乱码,提供以下两种解决方案: 1.修改字段类型 varchar是采用单字节存数 nvarchar采用的是unico编码,存储两个字节 一个英文字母存varchar格式,占一个字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaNJkz.html" rel="bookmark" class="title">利用听云Server和听云Network实测Kubernetes和Mesos在高并发下的网络性能</a>
					<div>
						文章出自:听云博客        随着公司业务的不断增长,我们的应用数量也有了爆发式增长.伴随着应用爆发式的增长,管理的难度也随之加大.如何在业务爆发增长的同时快速完成扩容成了很大的挑战.Docker ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRLv6z.html" rel="bookmark" class="title">在阿里云上运行ASP&period;NET Docker应用</a>
					<div>
						微软的.NET开源后可以运行在Mac和Linux平台,也支持运行在Docker容器里.我们今天要尝试的是在Mac上开发一个.NET应用,并且把它用Docker跑起来,然后部署到阿里云容器服务上. 本文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2DGXb.html" rel="bookmark" class="title">2009年IT就业形势的分析</a>
					<div>
						2008年下半年发生了席卷全球的金融海啸,到2008底金融危机已经渗透到实体经济,冰岛面临国家破产的边缘,日本经济出现了负2位数字增长.中国当然也不能独善其身,在2009年初已经出现各大外企裁员消息, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAeJkM.html" rel="bookmark" class="title">软通动力携手华为助力打造南通国家级智慧城市</a>
					<div>
						为加快&quot;两化&quot;融合进程.促进产业结构调整,南通市政府,软通动力信息技术(集团)有限公司(以下简称:软通动力)与华为技术有限公司(以下简称:华为)于6月28日在深圳共同签署智慧城市战 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NxmRz.html" rel="bookmark" class="title">如何在MDI子窗体中使用TransparencyKey属性</a>
					<div>
						问题描述 如何在MDI子窗体中使用TransparencyKey属性如果窗体不是MDI子窗体,则可以通过设置TransparencyKey属性使得窗体透明.但如果窗体时MDI子窗体,这个属性就无效了. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7ldWz.html" rel="bookmark" class="title">checkbox的选择问题</a>
					<div>
						问题描述 4个checkbox,选中一个,其他取消掉.在FORM_LOAD里面添加:if(checkBox1.Checked){checkBox2.Checked=false;checkBox3.Ch ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1yLOz.html" rel="bookmark" class="title">我从编程总结的 22 个经验</a>
					<div>
						以下所列是我在这些年来软件开发工作过程中受到的启发,还有总结而来的好经验. 开发 从小事做起,然后再扩展 无论是创建一个新的系统,还是在现有的系统中添加新的功能,我总是从一个简单到几乎没有任何所需功能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRYdap.html" rel="bookmark" class="title">视频点播功能的开通</a>
					<div>
						近日,优酷官方微信(微信号:youku2012)开通视频点播功能,帮助网友提供想看的视频,包括电视剧.电影.MV等内容,用户通过微信发送相关剧名.片名或歌名,优酷将通过微信对话为用户提供精准的视频播放 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWw7mz.html" rel="bookmark" class="title">回收站功能在 Linux 中的实现</a>
					<div>
						本文仿照 Windows 回收站的功能,运用 Bash 脚本在 Linux 上做了实现,创建 delete 脚本代替 rm 命令对文件或目录进行删除操做.该脚本实现了以下功能:对大于 2G 的文件或目 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRQQap.html" rel="bookmark" class="title">《Unreal Engine 4蓝图可视化编程》一导读</a>
					<div>
						前 言 Unreal Engine 4蓝图可视化编程 游戏引擎(例如虚幻引擎4)作为强大的商业游戏的制作工具,越来越受传统游戏工作室以外的新老游戏开发者所欢迎.虚幻引擎为过去10年中发布的许多最受欢迎 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrq5jvb.html" rel="bookmark" class="title">c&num;中的string只能保存unicode格式的字符串吗，我需要一个能保存utf-8字符串的变量，有没有其他办法？</a>
					<div>
						问题描述 问题如题,c#中string如何保存utf-8编码的字符串 解决方案 解决方案二:自己用Encoding编码解决方案三:问题描述清楚,到底什么需求不要拿自己拍脑袋想的方案来问解决方案四:用E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JA0Wz.html" rel="bookmark" class="title">各位曾使用过delphi的朋友请进。。。thanks</a>
					<div>
						问题描述 各位:Delphi中有个DBLookupComboBox1控件,请问VS2005中有能实现其功能的控件吗??(注:comboBox的中dataSource,displayMember,val ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoyZ7M.html" rel="bookmark" class="title">《R的极客理想&mdash;&mdash;高级开发篇 A》一一1&period;4　常用连续型分布介绍及R语言实现</a>
					<div>
						1.4 常用连续型分布介绍及R语言实现 问题 如何让R语言画出概率分布函数曲线? 引言 随机变量在我们的生活中处处可见,如每日天气.股价涨跌.彩票中奖等,这些事情都是事前不可预言其结果的,就算在相同的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3J780z.html" rel="bookmark" class="title">default-线程从服务器得到的的值付给线程外的一个变量，但为空？求大神解决帮忙啊</a>
					<div>
						问题描述 线程从服务器得到的的值付给线程外的一个变量,但为空?求大神解决帮忙啊 # A fatal error has been detected by the Java Runtime Enviro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV7ldDb.html" rel="bookmark" class="title">Roberts Hawaii旅游公司被黑，信用卡和个人信息泄漏</a>
					<div>
						本文讲的是Roberts Hawaii旅游公司被黑,信用卡和个人信息泄漏,你去年去Hawaii旅游过吗?近日,Roberts Hawaii旅游公司发出警告声明称,该公司发生的数据泄漏事件可能会影响20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2nvWM.html" rel="bookmark" class="title">常见的80004005错误及其解决方法</a>
					<div>
						在编写WEB应用程序的过程中,我们常常要跟数据库打交道,例如我们日常经常用的数据库ACCESS.SQL SERVER等.在连接这些数据库的时候,系统往往会给我们一些象这类&quot;80004005& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8N8A9b.html" rel="bookmark" class="title">为什么我的服务器 练就不了远程计算机&quest;</a>
					<div>
						问题描述 如题.为什么我的服务器练就不了远程计算机? 解决方案 解决方案二: 解决方案三:服务器开通远程桌面可以远程管理解决方案四:服务器用的什么系统?看看是不是mstsc版本问题?解决方案五: 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEJYanM.html" rel="bookmark" class="title">N90是原道近期推出的一款旗舰平板</a>
					<div>
						N90是原道近期推出的一款旗舰平板,其搭载9.7英寸IPS原装IPAD2屏幕1G主频处理器1GB运行内存16GB大容量存储支持电容十点触控前后双http://www.aliyun.com/zixun/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1DovKb.html" rel="bookmark" class="title">e代驾宣布全面调整代价收费模式&comma;推广期定价为19元每小时</a>
					<div>
						域名城(domain.cn)1月30日消息,e代驾今日对外宣布全面调整白天代驾业务的收费模式,白天代驾(早7点-晚7点)由之前按照公里收费调整为按小时计费,推广期定价为19元每小时. 代驾CEO杨家军 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLByLRb.html" rel="bookmark" class="title">jsp-数据库里有数据。网站却显示不出来。这是怎么回事。</a>
					<div>
						问题描述 数据库里有数据.网站却显示不出来.这是怎么回事. 解决方案 你检查一下你从DB获取数据的代码,控制层和服务层都要检查,还有页面jsp或html也要检查,仅仅是这些信息,我们是无法判断你错在哪 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
